unit BitOp;
(*
 * Module:        a    
 *             c 32- 
 * Version:    2.2 (25.10.2008)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   2006, 2008 .
 *
 * Version:    2.2 (25.10.2008)
 * Realized:          Unicode
 *             . THasButtonBitmapHeader
 *
 * Version:    2.1 (18.09.2007)
 * Realized:      XP. .  ThemeEnabled   DrawBkTheme
 *               OnDrawBorder, OnDrawImage    .
 *               DrawBkTheme
 *)
interface
uses Windows, Classes, SysUtils, {$IFDEF VER130}{$ELSE}RTLConsts, {$ENDIF}
  Graphics,
  {$IFDEF VER130}{$ELSE}GraphUtil, {$ENDIF} //  5   GraphUtil
  GraphUtilEx,
  ImgList, Buttons;

resourcestring
  Errorpf32bit = '   32- ';
  ErrorInfo = '    ';
  NoApplication = '   Application';
const
  MaxButtons = 220; //    
  MinSize = 8; //  
  {$IFDEF VER130}
  SAssignError = 'Cannot assign a %s to a %s';
  WM_THEMECHANGED = $031A;
  {$ENDIF}
type
  TArrayColor = array[0..512] of TColor;
  PArrayColor = ^TArrayColor;
  TCepStateButton = (csbNormal, csbHot, csbPushed, csbDisabeled);
  TCepButtonBorderEx = (cbbNormal, cbbNoRigth, cbbNoLeft);
  TCepButtonBorder = (CepSingleBorder, CepFlatBorder, CepNoBorder, CepXPBorder);

//         
//Bit       
//P             .  P<>nil,
//             .
//BitInfo      .
procedure GetDib(Bit: TBitmap; var P: PArrayColor; var BitInfo: TBitmapInfo);
//      
//Bit       
//P             .  P<>nil,
//              
//BitInfo      .
procedure SetDib(Bit: TBitmap; var P: PArrayColor; var BitInfo: TBitmapInfo);
//     
function MixColor(C1, C2: TColor): TColor;
//   
procedure ColorToAlpha(var Dest; Color: TColor; Count: integer);
//    
procedure CopyAlphaColorNew(var Dest; var Source; SourceAlphaBlendValue: Byte; Count: integer; B: byte);

//         NumByte
//Source       .    32-
//          
//Dest        
//Count       
//NumByte     (0..3)     3.
procedure DwordToByte(Source: PArrayColor; Dest: PByteArray; Count: integer; NumByte: Byte);
//  . DwordToByte
procedure ByteToDword(Source: PByteArray; Dest: PArrayColor; Count: integer; NumByte: Byte);
//    (, ,  )
//PSource        
//PDest          
//Count        ( )
procedure BlurByteHor(PSource, PDest: PByteArray; Count: integer);
//    (, ,  )
//PSource        
//PDest          
//Count     
//Width     
procedure BlurByteVert(PSource, PDest: PByteArray; Count, Width: integer);

//    ""
//Source       
//BitInfoSource      
//TransparentColor  ,      
//           clNone,     
//CountBlur    (0   )
//AlphaBlendValue      (0    )
procedure BitmapToShadow(Source: PArrayColor;
  BitInfoSource: TBitmapInfo;
  TransparentColor: TColor;
  CountBlur: Byte = 1;
  AlphaBlendValue: Byte = 255);
//     c  
//Source       ,   .
//Dest         ,    .
//           32-  
//BitInfoSource, BitInfoDest  ,    
//X, Y         ,  .
//TransparentColor  ,      
//          b clNone,     
//AlphaBlendValue     (0    )
procedure CopyAlphaBitmap(Source, Dest: PArrayColor;
  BitInfoSource, BitInfoDest: TBitmapInfo;
  X, Y: integer;
  TransparentColor: TColor = clFuchsia;
  AlphaBlendValue: Byte = 255);
//     c   
//c   
//Source       ,   .
//Dest         ,    .
//           32-  
//BitInfoSource, BitInfoDest  ,    
//X, Y         ,  .
//TransparentColor  ,      
//          b clNone,     
//AlphaBlendValue     (0    )
//CountBlur    (0   )
//Offset      .
//           Offset<0,      (  RTL),
//             
procedure CopyShadowAlphaBitmap(Source, Dest: PArrayColor;
  BitInfoSource, BitInfoDest: TBitmapInfo;
  X, Y: integer;
  TransparentColor: TColor = clFuchsia;
  AlphaBlendValue: Byte = 255;
  CountBlur: Byte = 1;
  Offset: ShortInt = 1);
//  
//Dest         ,   
//           32-  
//Color    ,    
//Count       
procedure ColorToMonocrom(var Dest; Color: TColor; Count: integer);
//  .
//Dest         ,   
//           32-  
//Color    ,    
//Count       
procedure ColorToGray(var Dest; Color: TColor; Count: integer);
//   
//Dest         ,   
//BitInfoDest    
//Color    ,    
procedure ColorToDull(Dest: PArrayColor; BitInfoDest: TBitmapInfo; Color: DWORD);
//    
procedure DrawIcon(const Canvas: TCanvas; ARect: TRect; Icon: TIcon);
//     
procedure DrawDockCaption(const Canvas: TCanvas;
  CaptionRect: TRect;
  MarginLeft, MarginRight: integer;
  const Horizontal: boolean;
  Caption: string;
  const StartColor, EndColor, FontColor: TColor;
  const Focused: Boolean;
  const Icon: TIcon;
  const D: integer = 2);
procedure DrawPin(Canvas: TCanvas;
  ARect: TRect;
  Color: TColor;
  Pined: boolean);
// DrawBkTheme      Windows
function DrawBkTheme(DC: HDC; Rect: TRect; State: TCepStateButton; Flat, Checked: boolean;
  BorderEx: TCepButtonBorderEx;
  ClipRect: PRect = nil): boolean;

type
  ECepBitError = class(Exception)
  end;

  TRichImageList = class;

  //SelectedColor -   
  TOnDrawBorder = function(Sender: TRichImageList; Bitmap: TBitmap; ARect: TRect; var SelectedColor: TColor): boolean of object;
  TOnDrawImage = function(Sender: TRichImageList; Bitmap: TBitmap; ARect: TRect): boolean of object;

  //       
  TRichImageList = class(TGraphic)
  private
    fBuf: Pointer;
    fBlend: Byte;
    fOnDrawBorder: TOnDrawBorder;
    fOnDrawImage: TOnDrawImage;
    fDrawing: boolean;
    function GetBkColor: TColor;
    function GetBorder: TCepButtonBorder;
    function GetCaption: string;
    function GetChecked: boolean;
    function GetSelectedColor: TColor;
    function GetBorderColor: TColor;
    function GetEnabled: boolean;
    function GetHot: boolean;
    function GetImageList: TCustomImageList;
    function GetIndex: integer;
    function GetPushed: boolean;
    procedure SetBkColor(const Value: TColor);
    procedure SetBorder(const Value: TCepButtonBorder);
    procedure SetCaption(const Value: string);
    procedure SetChecked(const Value: boolean);
    procedure SetSelectedColor(const Value: TColor);
    procedure SetBorderColor(const Value: TColor);
    procedure SetEnabled(const Value: boolean);
    procedure SetHot(const Value: boolean);
    procedure SetImageList(const Value: TCustomImageList);
    procedure SetIndex(const Value: integer);
    procedure SetPushed(const Value: boolean);
    procedure SetBlend(const Value: Byte);
    function GetLayout: TButtonLayout;
    procedure SetLayout(const Value: TButtonLayout);
    function GetSpacing: byte;
    procedure SetSpacing(const Value: byte);
    procedure FlatBorder(ACanvas: TCanvas; R: TRect; Color: TColor; Push: boolean; Percent: integer = -1);
    function GetAdjusted: boolean;
    procedure SetAdjusted(const Value: boolean);
    procedure UpdateBitmap(var Bitmap: TBitmap; var ARect: TRect);
    procedure DrawText(ACanvas: TCanvas; var R: TRect; uFormat: Cardinal; Transparent: boolean);
    function GetThemeEnabled: boolean;
    procedure SetThemeEnabled(const Value: boolean);
    function GetCepButtonBorderEx: TCepButtonBorderEx;
    procedure SetCepButtonBorderEx(const Value: TCepButtonBorderEx);
  protected
    function GetEmpty: Boolean; override;
    function GetHeight: Integer; override;
    function GetPalette: HPALETTE; override;
    function GetTransparent: Boolean; override;
    function GetWidth: Integer; override;
    procedure SetHeight(Value: Integer); override;
    procedure SetPalette(Value: HPALETTE); override;
    procedure SetTransparent(Value: Boolean); override;
    procedure SetWidth(Value: Integer); override;
    function Equals(Graphic: TGraphic): Boolean; override;
    procedure Draw(ACanvas: TCanvas; const Rect: TRect); override;
    procedure GetRectIMG(ACanvas: TCanvas; var BitRect, TextRect: TRect); dynamic;
    function DoDrawBorder(Bitmap: TBitmap; ARect: TRect; var SelectedColor: TColor): boolean; virtual;
    function DoDrawImage(Bitmap: TBitmap; ARect: TRect): boolean; virtual;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    procedure AssignTo(Dest: TPersistent); override;
    property Caption: string read GetCaption write SetCaption;
    property ImageList: TCustomImageList read GetImageList write SetImageList;
    property Index: integer read GetIndex write SetIndex;
    property Checked: boolean read GetChecked write SetChecked;
    property Hot: boolean read GetHot write SetHot;
    property Enabled: boolean read GetEnabled write SetEnabled;
    property Pushed: boolean read GetPushed write SetPushed;
    property Adjusted: boolean read GetAdjusted write SetAdjusted;
    property BorderColor: TColor read GetBorderColor write SetBorderColor;
    property SelectedColor: TColor read GetSelectedColor write SetSelectedColor;
    property BkColor: TColor read GetBkColor write SetBkColor;
    property Border: TCepButtonBorder read GetBorder write SetBorder;
    property Blend: Byte read fBlend write SetBlend;
    property Layout: TButtonLayout read GetLayout write SetLayout;
    property Spacing: byte read GetSpacing write SetSpacing;
    // ,     
    // XP,     CepSingleBorder  CepFlatBorder
    property ThemeEnabled: boolean read GetThemeEnabled write SetThemeEnabled;
    //  XP.     CepFlatBorder  
    //    XP
    property CepButtonBorderEx: TCepButtonBorderEx read GetCepButtonBorderEx write SetCepButtonBorderEx;
    //   True,    Windows XP.
    // :  ThemeEnabled    .
    //       , ..   ,
    //            
    function IsTheme: boolean;
    function DrawBorder(var Bitmap: TBitmap; ARect: TRect): TColor;
    procedure DrawImage(var Bitmap: TBitmap; var ARect: TRect);
    procedure DrawAll(var Bitmap: TBitmap; Font: TFont; ARect: TRect);
    procedure LoadFromStream(Stream: TStream); override;
    procedure SaveToStream(Stream: TStream); override;
    procedure LoadFromClipboardFormat(AFormat: Word; AData: THandle;
      APalette: HPALETTE); override;
    procedure SaveToClipboardFormat(var AFormat: Word; var AData: THandle;
      var APalette: HPALETTE); override;

    property OnDrawBorder: TOnDrawBorder read fOnDrawBorder write fOnDrawBorder;
    property OnDrawImage: TOnDrawImage read fOnDrawImage write fOnDrawImage;
  end;

//    
procedure ClearHasButtonBitmap;
//       XP (   )
function UnloadThemeLib: boolean;
//     WM_THEMECHANGED
function HookThemeChanged: boolean;

implementation
...
