unit CSplashWindow;
// TSplashWindow   TThreadWindow
//      
// TCSplashWindow     TSplashWindow
//       'SPLASH',  'SPLASH_XX'
//( XX     ),    
//      ,     
//3 .         TCSplashWindow
//  .
//:  . . 2005 ... 2009
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  WindowThread, CWindowThread, Math;
resourcestring
  ErrorCount = '    TCSplashWindow.     ';
  //   
  TextDefaultValue = ': %ProductVersion%' + #13#10 +
                    '%LegalCopyright%' + #13#10 +
                    '%FileDescription%';
  //   
  CaptionDefaultValue = '%ProductName%';
const
  SplashName = 'SPLASH';    //       
  DefaultHeight = 320;      //      .
  DefaultWidth = 256;
  VersionInfoFields: array [0..11] of string = ('FileVersion',
                                               'Build',
                                               'Version',
                                               'CompanyName',
                                               'FileDescription',
                                               'InternalName',
                                               'LegalCopyright',
                                               'LegalTrademarks',
                                               'OriginalFilename',
                                               'ProductName',
                                               'ProductVersion',
                                               'Comments');

type
  TCSplashWindow = class(TCWindowThread)
  private
    fResourceName: string;
    fStayOnTopSec: integer;
    fBitmap: TBitmap;
    procedure SetStayOnTopSec(const Value: integer);
  protected
    procedure SetBitmap(const Value: TBitmap); virtual;
    function CreateWindow: TThreadWindow; override;
    procedure SetVisible(const Value: boolean); override;
  public
    property Bitmap: TBitmap read fBitmap write SetBitmap;
  published
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
        ///  <summary>    </summary>

    property ResourceName:string read fResourceName write fResourceName;
    property IconSize default 16;
    property Interval default 0;
    property AlphaShow default false;
    property UseSysFont default false;
    property Percent default 0;
    property Height default DefaultHeight;
    property Width default DefaultWidth;
    property Color default clBtnFace;
    /// <summary> TotalTimeSec  StartTime  ,    
    ///              (  3 )</summary>
    property TotalTimeSec default 3;
    //          StayOnTop
    property StayOnTopSec: integer read fStayOnTopSec write SetStayOnTopSec default 2;
  end;

  TCSplashWindowClass = class of TCSplashWindow;

const
  UM_GetBitmap = WM_USER + 113;
  UM_SetBitmap = WM_USER + 114;
type
  TUMGetSetBitmap = packed record
    Msg: Cardinal;
    IndexProp: Word;
    Part: Word;
    Value: TBitmap;
    Result: Longint;
  end;

  TSplashWindow = class (TThreadWindow)
  private
    fBkBitmap: TBitmap;
    fBitmap: TBitmap;
    fFirstShow:boolean;
    fStayOnTopSec: integer;
    procedure SetBitmap(const Value: TBitmap);
    function GetBitmap: TBitmap;
    procedure UMGetBitmap(var Message: TUMGetSetBitmap); message UM_GetBitmap;
    procedure UMSetBitmap(var Message: TUMGetSetBitmap); message UM_SetBitmap;
  protected
    procedure DrawWND(DC:HDC; ARect:TRect); override;
    procedure DrawCaption(DC: HDC; ARect: TRect; Text: PChar; Len:integer); override;
    procedure DrawText(DC: HDC; ARect: TRect; Text: PChar; Len:integer); override;
    procedure DrawIcon(DC: HDC; ARect: TRect; Icon: HIcon; Brush: HBrush); override;
    procedure DrawTime(DC: HDC; ARect: TRect; StartTime, TotalTime: TDateTime); override;
    procedure UpdateLayout(ClientRect: TRect; var ElementPos: TElementPos); override;
    procedure Change(var UpdateAreas: TUpdateAreas); override;
    function DefaultBoundsRect: TRect; override;
    procedure DrawBackground(DC: HDC; ARect: TRect; Ctl3D: boolean); override;
  public
    procedure AfterConstruction; override;
    destructor Destroy; override;
    //  
    property Bitmap:TBitmap read GetBitmap write SetBitmap;
    property StayOnTopSec: integer read fStayOnTopSec write fStayOnTopSec;
  end;

var
  //  "" ,    SplashWindow
  //  nil,   TCSplashWindow
  DefaultSplashClass: TCSplashWindowClass;
  //  ,     dfm ,
  //    .
  //  ''      "" 
  DefaultSplashClassName: string;
  /// <summary>      
  /// 1.  DefaultInstance,   0
  /// 2.      (ENU, RUS  ..). . FindResourceHInstance
  /// 3.   . . HInstance
  /// 4.      (Dll  Bpl),  DefaultInstance = 0</summary>
  DefaultInstance: HModule;


///<summary> SplashWindow  ""  ( 
/// ,        ),
///     ,  </summary>
function SplashWindow:TCSplashWindow;
///  <summary>     .</summary>
procedure ShowSplash;

procedure Register;

implementation
...
