unit CWindowThread;
// TCWindowThread   TComponent
// TThreadWindow     
// .       
//Icons.res.     MesIcon9
//:  . . 2005 - 2008
interface
{$I Directives.inc}
uses
  Windows, Messages, SysUtils, Classes, WindowThread, Controls, Graphics
  {$IFDEF DELPHI_6_UP}, GraphUtil{$ENDIF}
  , Forms;

type
  TPosWindowThread = (pwtDefault, pwtDesigned, pwtTopLeft, pwtBottomRight);

  TClassThreadWindow = class of TThreadWindow;

  TCWindowThread = class(TComponent)
  private
    fSetProp: boolean;
    fChanged: boolean;
    fWindow: TThreadWindow;
    fText: String;
    fCaption: TCaption;
    fClassWindow: TClassThreadWindow;
    fInterval: DWORD;
    fEnabled: boolean;
    fCanceled: boolean;
    fCtl3d: boolean;
    fPercent: Integer;
    fStartTime: TDateTime;
    fTotalTime: TDateTime;
    fColor: TColor;
    fCaptionColor: TColor;
    fFont: TFont;
    fCaptionFont: TFont;
    fTimerFont: TFont;
    fUseSysFont: boolean;
    fAlphaShow: boolean;
    fBoundsRect: TRect;
    fIcon: TIcon;
    fIconSize: integer;
    fPosition: TPosWindowThread;
    fIconResourceName: string;
    fIconIndex: integer;
    fIconUpdating: boolean;
    function GetVisible: boolean;
    procedure SetText(const Value: String);
    procedure SetCaption(const Value: TCaption);
    function GetInterval: DWORD;
    procedure SetInterval(const Value: DWORD);
    function GetEnabled: boolean;
    procedure SetEnabled(const Value: boolean);
    function GetCanceled: boolean;
    procedure SetCanceled(const Value: boolean);
    procedure SetCtl3d(const Value: boolean);
    function GetPercent: Integer;
    procedure SetPercent(const Value: Integer);
    function GetStartTime: TDateTime;
    procedure SetStartTime(const Value: TDateTime);
    function GetTotalTime: TDateTime;
    procedure SetTotalTime(const Value: TDateTime);
    function GetTotalTimeSec: integer;
    procedure SetTotalTimeSec(const Value: integer);
    procedure SetColor(const Value: TColor);
    procedure SetCaptionColor(const Value: TColor);
    procedure SetFont(const Value: TFont);
    procedure ChangeFont(Sender: TObject);
    procedure ChangeCaptionFont(Sender: TObject);
    procedure SetUseSysFont(const Value: boolean);
    procedure SetCaptionFont(const Value: TFont);
    procedure SetAlphaShow(const Value: boolean);
    function GetBoundsRect: TRect;
    procedure SetBoundsRect(const Value: TRect);
    procedure SetIcon(const Value: TIcon);
    procedure ChangeIcon(Sender: TObject);
    procedure SetIconSize(const Value: integer);
    procedure ReaderBounds(Reader: TReader);
    procedure WriterBounds(Writer: TWriter);
    procedure SetPosition(const Value: TPosWindowThread);
    function GetHeight: integer;
    function GetWidth: integer;
    procedure SetHeight(const Value: integer);
    procedure SetWidth(const Value: integer);
    procedure SetTimerFont(const Value: TFont);
    procedure ChangeTimerFont(Sender: TObject);
    procedure SetIconResourceName(const Value: string);
    function IconByResourceName(Name: string): HIcon;
    procedure SetIconIndex(const Value: integer);
    procedure UpdateIconHande(Window: TThreadWindow; IconResourceName: string);
  protected
    procedure UpdateProperties(Window: TThreadWindow);
    function CreateWindow: TThreadWindow; virtual;
    procedure FreeWindow; virtual;
    procedure DefineProperties(Filer: TFiler); override;
    procedure SetVisible(const Value: boolean); virtual;
    //       
    procedure CalcRect(var R: TRect); virtual;
  public
    property Window: TThreadWindow read fWindow;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    //   ,    TThreadWindow
    property ClassWindow: TClassThreadWindow read fClassWindow write fClassWindow;
    property TotalTime: TDateTime read GetTotalTime write SetTotalTime stored false;
    property StartTime: TDateTime read GetStartTime write SetStartTime;
    property BoundsRect: TRect read GetBoundsRect write SetBoundsRect;
  published
{summary
param (with parameter name="name")
returns
permission
remarks
comments}
    ///  <summary>  ,           Visible</summary>
    property Position: TPosWindowThread read fPosition write SetPosition default pwtDefault;
    //    ,    , 
    //  Font, CaptionFont, TimerFont
    property UseSysFont: boolean read fUseSysFont write SetUseSysFont default true;
    //  Visible   Run-Time    
    property Visible: boolean read GetVisible write SetVisible stored false;
    //         Visible
    //  True,      
    property Interval: DWORD read GetInterval write SetInterval default 1000;
    //       ( c)
    //     0,      
    property TotalTimeSec: integer read GetTotalTimeSec write SetTotalTimeSec default 0;
    //        ""
    //      
    property Canceled: boolean read GetCanceled write SetCanceled stored false;
    //    Enabled,    "",
    //       
    property Enabled: boolean read GetEnabled write SetEnabled default false;
    //     10.  -1,   
    //   
    property Percent: Integer read GetPercent write SetPercent default -1;
    //  
    property Text: String read fText write SetText;
    // 
    property Caption: TCaption read fCaption write SetCaption;
    //       ,  
    property Ctl3d: boolean read fCtl3d write SetCtl3d default false;
    //  
    property Color: TColor read fColor write SetColor default cl3DLight;
    //  
    property CaptionColor: TColor read fCaptionColor write SetCaptionColor default clInActiveCaption;
    //  ,  UseSysFont = False
    property Font: TFont read fFont write SetFont;
    //  ,  UseSysFont = False
    property CaptionFont: TFont read fCaptionFont write SetCaptionFont;
    //   ,  UseSysFont = False
    property TimerFont: TFont read fTimerFont write SetTimerFont;
    //    ,     
    //   .  ,   
    property AlphaShow: boolean read fAlphaShow write SetAlphaShow default false;
    //  
    property Icon: TIcon read fIcon write SetIcon;
    //    .
    //    Icon,  IconResourceName
    property IconResourceName: string read fIconResourceName write SetIconResourceName;
    //  
    property IconSize: integer read fIconSize write SetIconSize default 32;
    //   
    property IconIndex: integer read fIconIndex write SetIconIndex default 0;
    //  
    property Height: integer read GetHeight write SetHeight stored false;
    //  
    property Width: integer read GetWidth write SetWidth stored false;
  end;

procedure Register;

implementation
...
