unit CepStyleActnCtrls;
(*
 * Module:          "Cep Style"
 * Version:    2.5 (02.12.2008)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   2006  2008 .
 *
 * Version:    2.5 (02.12.2008)
 * Realized:      SmallIcons,   TActionManager.LargeImages  ..
 *
 * Version:    2.0 (22.11.2007) b
 * Realized:    TGradientActionToolBar  TGradientActionMainMenuBar -
 *                 TControlBarCep
 *
 * Version:    1.6 (31.07.2007)
 * Realized:   1.     InternalLoadFromStream  InternalSaveToStream
 *             2.  TGradientActionToolBar  TGradientActionMainMenuBar
 *                TCustomGradientActionToolBar
 *              TCustomGradientActionMainMenuBar .
 *)
interface
{$I Directives.inc}
uses Windows, Types, Messages, SysUtils, Classes, Controls, ActnCtrls, ActnMan, ActnMenus, {XPStyleActnCtrls,}
  ActnColorMaps, XPActnCtrls, ActnList, ListActns, ExtCtrls, StrUtils,
  Graphics, GraphUtil, GraphUtilEx, StdActns, Contnrs, ToolWin,
  BandActn, Buttons, CustomizeDlg, BitOp, CepStyleUtl, ImageListCep, Math;

resourcestring
  CapCustomize = ' ';
  ErrStreamFormat = '  ';
  ErrStreamVer = ' "%s"  ';
type
  TControlKind = (kcBtn, kcDDBtn, kcMenuBtn, kcMenuItem, kcARItem, kcCombo,
    kcSBtn, kcExpBtn, kcCustPop, kcPop, kcCMap, kcListCep);

  //      
  TCepStyleActionBars = class(TActionBarStyleEx {TXPStyleActionBars})
  protected
    function ControlKind(ActionBar: TCustomActionBar;
      AnItem: TActionClientItem): TControlKind; virtual;
  public
    function GetColorMapClass(ActionBar: TCustomActionBar): TCustomColorMapClass; override;
    function GetControlClass(ActionBar: TCustomActionBar;
      AnItem: TActionClientItem): TCustomActionControlClass; override;
    function GetPopupClass(ActionBar: TCustomActionBar): TCustomPopupClass; override;
    function GetAddRemoveItemClass(ActionBar: TCustomActionBar): TCustomAddRemoveItemClass; override;
    function GetStyleName: string; override;
    function GetScrollBtnClass: TCustomToolScrollBtnClass; override;
  end;

  //   
  TCepStyleButton = class(TCustomButtonControl {TXPStyleButton}, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
    procedure DrawShadowedText(Rect: TRect; Flags: Cardinal; Text: string;
      TextColor, ShadowColor: TColor); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    constructor Create(AOwner: TComponent); override;
    function GetImg(Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //    
  TCepStyleDropDownBtn = class(TCustomDropDownButton {TXPStyleDropDownBtn}, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
    procedure DrawShadowedText(Rect: TRect; Flags: Cardinal; Text: string;
      TextColor, ShadowColor: TColor); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    function GetPopupClass: TCustomActionBarClass; override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    constructor Create(AOwner: TComponent); override;
    function GetImg(Small: boolean = true): TRichImageList;
    procedure FreeImg;
    procedure Click; override;
  end;

  //    
  TCepStyleMenuButton = class(TCustomMenuButton {TXPStyleMenuButton}, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    procedure DrawShadowedText(Rect: TRect; Flags: Cardinal; Text: string;
      TextColor, ShadowColor: TColor); override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    function GetImg(Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //   
  TCepStylePopupMenu = class(TXPStylePopupMenu)
  protected
    function GetExpandBtnClass: TCustomMenuExpandBtnClass; override;
  end;

  //   ,  ,    
  TCepStyleExpandBtn = class(TXPStyleExpandBtn)
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
  end;

  //     ,   
  TCepStyleAddRemoveItem = class({TCustomAddRemoveItem}TXPStyleAddRemoveItem, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    procedure DrawBackground(var PaintRect: TRect); override;
    function GetImageSize: TPoint; override;
  public
    destructor Destroy; override;
    function GetImg(Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //   ,       
  TCepStyleCustomizePopup = class(TXPStyleCustomizePopup)
  private
    FSeparatorItem: TActionClientItem;
    FARItem: TActionClientItem;
    FCustomizeItem: TActionClientItem;
    procedure CustomizeActionBarsExecute(Sender: TObject);
  protected
    function DoItemClicked(AnItem: TCustomActionControl): TActionClientItem; override;
    procedure SetActionClient(const Value: TActionClient); override;
    function GetAddRemoveItemClass: TCustomAddRemoveItemClass; override;
  public
    procedure CloseMenu; override;
    property ARItem: TActionClientItem read FARItem;
  end;

  //    
  TCepStyleMenuItem = class(TXPStyleMenuItem, IImg)
  private
    fImg: TRichImageList;
  protected
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawSeparator(const Offset: Integer); override;
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    function GetImageSize: TPoint; override;
    procedure CalcLayout; override;
  public
    destructor Destroy; override;
    function GetImg(Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //    
  TCustomGradientActionToolBar = class(TCustomActionDockBar {TCustomActionToolBar}, IStreamPersist, ISysMenuEx)
  private
    fEnableClose: boolean;
    fonShowCustomize: TNotifyEvent;
    FPopupBar: TCustomActionBar;
    fHiddenItems: TStack;
    fItemsChanged: boolean;
    fOldBarHeight: integer;
    fOldBarWidth: integer;
    procedure SetEnableClose(const Value: boolean);
    procedure FreeHiddenItems;
  protected
    function GetFloatingDockSiteClass: TWinControlClass; override;
    procedure DrawBackground; override;
    procedure SetParent(AParent: TWinControl); override;
    procedure CustomAlignPosition(Control: TControl;
      var NewLeft, NewTop, NewWidth, NewHeight: Integer; var AlignRect: TRect;
      AlignInfo: TAlignInfo); override;
    function IsEnabledEx: boolean;
    function IsChevronEx: boolean;
    function CaptionEx: WideString;
    procedure ExecuteEx(X, Y: integer);
    function GetPopupClass: TCustomActionBarClass; virtual;
    procedure UpdateHiddenItems(var AHiddenItems: TStack); virtual;
    procedure Resize; override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
    property onShowCustomize: TNotifyEvent read fonShowCustomize write fonShowCustomize;
    property EnableClose: boolean read fEnableClose write SetEnableClose default true;
    function CalcDockedWidth: Integer; override;
  published

  end;

  TGradientActionToolBar = class(TCustomGradientActionToolBar)
  public
    property Canvas;
  published
    property ActionManager;
    property Align default alTop;
    property AllowHiding default True;
    property Anchors;
    property BiDiMode;
    property Caption;
    property Color default clBtnFace;
    property ColorMap;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind default dkDock;
    property DragMode;
    property EdgeBorders default [];
    property EdgeInner;
    property EdgeOuter default esNone;
    property Enabled;
    property EnableClose;
    property Font;
    property HorzMargin;
    property HorzSeparator default True;
    property Orientation default boLeftToRight;
    property ParentBiDiMode;
    property ParentBackground default False;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property PersistentHotKeys default False;
    property PopupMenu;
    property ShowHint;
    property Spacing;
    property VertMargin;
    property Visible;
    property OnAlignInsertBefore;
    property OnAlignPosition;
    property OnControlCreated;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetControlClass;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
    property onShowCustomize;
  end;

  TItemClicked = procedure(Sender: TCustomActionControl) of object;

  //    
  //    .
  TCustomGradientActionMainMenuBar = class({TCustomActionDockBar}TCustomActionMainMenuBar, IStreamPersist)
  private
    fonItemClicked: TItemClicked;
  protected
    function DoItemClicked(AnItem: TCustomActionControl): TActionClientItem; override;
    function GetFloatingDockSiteClass: TWinControlClass; override;

    procedure DrawBackground; override;
    procedure SetParent(AParent: TWinControl); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    function CalcDockedWidth: Integer; override;
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
  published
    property onItemClicked: TItemClicked read fonItemClicked write fonItemClicked;
  end;

  TGradientActionMainMenuBar = class(TCustomGradientActionMainMenuBar)
    property Canvas;
  published
    property UseSystemFont default True;
    property ActionManager;
    property Align default alTop;
    property AllowHiding default False;
    property Anchors;
    property AnimateDuration default 150;
    property AnimationStyle default asDefault;
    property AutoFocus default True;
    property BiDiMode default bdLeftToRight;
    property Caption;
    property Color default clBtnFace;
    property ColorMap;
    property Constraints;
    property DragCursor;
    property DragKind default dkDock;
    property DragMode;
    property EdgeBorders default [];
    property EdgeInner default esRaised;
    property EdgeOuter default esLowered;
    property Enabled;
    property ExpandDelay default 4000;
    property Font;
    property HorzMargin;
    property ParentBiDiMode;
    property ParentBackground default False;
    property ParentColor default False;
    property ParentFont default False;
    property ParentShowHint;
    property PersistentHotKeys default False;
    property Shadows;
    property ShowHint;
    property Spacing;
    property VertMargin;
    property Visible;
    property WindowMenu;
    property OnAlignInsertBefore;
    property OnAlignPosition;
    property OnCanResize;
    property OnClick;
    property OnControlCreated;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnEnterMenuLoop;
    property OnExit;
    property OnExitMenuLoop;
    property OnGetControlClass;
    property OnGetPopupClass;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint;
    property OnPopup;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

  //TActionListCep -  ,   
  //  .     "Windows"
  TActionListCep = class(TCustomControlAction)
  private
    fCountUpdating: integer;
    fLinkedControls: TObjectList;
    function GetLinkedControlsCount: integer;
    procedure FindItemsByAction(List: TStringList);
    function AddControl(AItem: TActionClientItem; Control: TControl): boolean;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure AddedLinkedControl(AControl: TControl); dynamic;
    procedure DeletedLinkedControl(AControl: TControl); dynamic;
    procedure RefreshItems; dynamic;
    procedure UpdateItem(Item: TActionClientItem); dynamic;
    function DeleteInternalItem(Item: TActionClientItem): boolean; virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure BeginUpdate;
    procedure EndUpdate;
    property CountUpdating: integer read fCountUpdating;
    property LinkedControls: TObjectList read fLinkedControls; //   
    function AddLinkedControl(AControl: TControl): integer;
      //      .    
    function DeleteLinkedControl(Index: integer): integer; overload;
      //        
    function DeleteLinkedControl(AControl: TControl): integer; overload;
      //      
    property LinkedControlsCount: integer read GetLinkedControlsCount;
      //     
    procedure ClearInternal; dynamic;
      //     
  published
    property Caption;
    property Enabled;
    property HelpContext;
    property HelpKeyword;
    property HelpType;
    property Hint;
    property ImageIndex;
    property PopupMenu;
    property ShortCut;
    property SecondaryShortCuts;
    property Visible;
    property OnExecute;
    property OnHint;
    property OnUpdate;
  end;

  //TActionLinkedControlCep        .
  //           
  TActionLinkedControlCep = class(TAction)
  private
    fCreated: boolean;
    fControl: TControl;
    fInternal: boolean;
    fInvisibleEmpty: boolean;
    fInactiveEmpty: boolean;
    fNameAsControl: boolean;
    procedure SetControl(const Value: TControl);
    procedure SetInactiveEmpty(const Value: boolean);
    procedure SetInvisibleEmpty(const Value: boolean);
    procedure SetNameAsControl(const Value: boolean);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    property Internal: boolean read fInternal write fInternal;
  public
    constructor Create(AOwner: TComponent; AControl: TControl); reintroduce;
    procedure AfterConstruction; override;
    destructor Destroy; override;
    function Update: Boolean; override;
    function Execute: boolean; override;
  published
    property Control: TControl read fControl write SetControl;
    property InactiveEmpty: boolean read fInactiveEmpty write SetInactiveEmpty default false;
    property InvisibleEmpty: boolean read fInvisibleEmpty write SetInvisibleEmpty default false;
    property NameAsControl: boolean read fNameAsControl write SetNameAsControl default false;
  end;

var
  CepStyle: TCepStyleActionBars;

procedure Register;
//    
procedure CrearAllInternalActions(ActionList: TCustomActionList);
// 
procedure ActionManagerSave(Stream: TStream; Manager: TCustomActionManager);
// 
procedure ActionManagerLoad(Stream: TStream; Manager: TCustomActionManager);
//      
//   ,     ,
// ,       .
//  ,       !
procedure UpdateActionBars(ActionManager: TCustomActionManager);
//     
procedure DrawGliphControl(ActionControl: TCustomActionControl;
  MouseInControl: boolean;
  const Location: TPoint);
// /   
procedure InternalLoadFromStream(Stream: TStream; ABar: TCustomActionDockBar);
procedure InternalSaveToStream(Stream: TStream; ABar: TCustomActionDockBar);

implementation
...
