unit CepStyleUtl;
(*
 * Module:           TXToolDockFormCep,    ""
 *                "Drag and Dock"  .
 * Version:    1.0 (14.11.2007) b
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.boom.ru
 *
 * Copyright:   Cep Po 2007 .
 *)

interface
uses Windows, Messages, BitOp, Classes, Controls, Graphics, GraphUtil, ExtCtrls, ActnMan,
     ActnCtrls, Forms, Themes, SpeedButtonCep, InternalTimer,
     StdCtrls;
{$I Directives.inc}
resourcestring
  TextSysMenuEx = '';
  CapAR = '/ |,   ';
Const
  SC_SysMenuEx = WM_USER + 113;
  IDEventTimer = WM_USER + 114;
  UM_RESIZED = WM_USER + 115;
Type

  //     TRichImageList
  IImg=interface ['{01F38FA0-B41A-4A43-BA8F-937FBB008088}']
    function GetImg(Small: boolean = true): TRichImageList;
    procedure FreeImg;
  end;

  //     
  //IStreamCustomActionDockBar = interface ['{9EBE575F-8A39-43D6-8D74-F2DDD1BA2335}']
  //  procedure SaveToStream(Stream: TStream);
  //  procedure LoadFromStream(Stream: TStream);
  //end;

  //       
  //  ,    
  IDrawBackground = interface ['{2DA77A6D-4700-4CC9-BA76-7044DEEBC4B4}']
    function DrawBackgroundControl(Control: TControl; Canvas: TCanvas; ARect: TRect): boolean;
    procedure ColorsInfo(var ADrawingStyle: TBandDrawingStyle;
                         var AGradientDirection: TGradientDirection;
                         var AGradientStartColor: TColor;
                         var AGradientEndColor: TColor;
                         var AColor: TColor);
    function InsetsControl(const Control: TControl; var Insets: TRect):boolean;
  end;

  //         
  ISysMenuEx = interface ['{ED79395D-BE41-4C97-8B9C-0E133B4E31CD}']
    function IsEnabledEx: boolean;
    function IsChevronEx: boolean;
    function CaptionEx: WideString;
    procedure ExecuteEx(X, Y: integer);
  end;

  //  
  TSpecialKind = (skControlBarDropDown, skCaptionClose, skCaptionDropDown, skCaptionPin);
  TSpeedButtonCepSpecial = class (TSpeedButtonCep)
  private
    fActive: boolean;
    function OnDrawBorder(Sender: TRichImageList; Bitmap:TBitmap; ARect:TRect; var SelectedColor: TColor): boolean;
    function OnDrawImage(Sender: TRichImageList; Bitmap:TBitmap; ARect:TRect):boolean;
    procedure DrawThemed(Canvas: TCanvas; ARect: TRect);
    function GetSpecialKind: TSpecialKind;
    procedure SetActive(const Value: boolean);
    procedure SetSpecialKind(const Value: TSpecialKind);
    procedure UpdateBlend;
    procedure DrawCustomed(Canvas: TCanvas; ARect: TRect);
  protected
    procedure HotChanged; override;
  public
    constructor Create(AOwner: TComponent); override;
    property Active: boolean read fActive write SetActive;
    property SpecialKind: TSpecialKind read GetSpecialKind write SetSpecialKind;
  end;

  // 
  TXToolDockFormCep = class (TCustomDockForm)
  private
    fClient: TControl;
    fButtonClose: TSpeedButtonCepSpecial;
    fSysButton: TSpeedButtonCepSpecial;
    fEnableClose: boolean;
    FUpdatingSize: boolean;
    fOldCtl3D: Boolean;
    fOldRect: TRect;
    fEnableSysButton: boolean;
    fClientRect: TRect;
    fCaptionRect: TRect;
    fTextRect: TRect;
    fLastHitTest: integer;
    fCaptionPushed: boolean;
    fUpdateInterval: integer;
    fTimer: THandle;
    fSysButtonPushed: boolean;
    fTmpTimer: TInternalTimer;
    fTextCaption: WideString;
    procedure SetEnableClose(const Value: boolean);
    procedure ModifySystemMenu;
    function GetNcSize(var Dx, Dy: integer): boolean;
    function UpdateRGN(ARect: TRect): boolean;
    procedure WMNCCreate(var Message: TWMNCCreate); message WM_NCCreate;
    procedure WMACTIVATEAPP(var Message: TWMACTIVATEAPP); message WM_ACTIVATEAPP;
    procedure WMNCPAINT(var Message: TWMNCPAINT); message WM_NCPAINT;
    procedure WMACTIVATE(var Message: TWMACTIVATE); message WM_ACTIVATE;
    procedure WMERASEBKGND(var Message: TWMERASEBKGND); message WM_ERASEBKGND;
    procedure WMNCHITTEST(var Message: TWMNCHITTEST); message WM_NCHITTEST;
    procedure WMNCRBUTTONDOWN(var Message: TWMRBUTTONDOWN); message WM_NCRBUTTONDOWN;
    procedure WMNCRBUTTONUP(var Message: TWMRBUTTONUP); message WM_NCRBUTTONUP;
    procedure WMSETTEXT(var Message: TWMSETTEXT); message WM_SETTEXT;
    procedure WMTIMER(var Message: TWMTIMER); message WM_TIMER;
    procedure UMRESIZED(var Message: TMessage); message UM_RESIZED;
    procedure WMSYSCOMMAND(var Message: TWMSYSCOMMAND); message WM_SYSCOMMAND;
    procedure SetEnableSysButton(const Value: boolean);
    procedure InvalidateButtons;
    procedure SetUpdateInterval(const Value: integer);
    procedure KillTimer;
    procedure SetTimer;
    procedure SetSysButtonPushed(const Value: boolean);
    function NewFormSize(Dx, Dy: Integer; var NewWidth, NewHeight: Integer): boolean;
    procedure ExecuteEx;
    procedure OnCloseClick(Sender: TObject);
    procedure OnSysClick(Sender: TObject);
    procedure AfterExecuteEx(Sender: TObject);
  protected
    procedure DoAddDockClient(Client: TControl; const ARect: TRect); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure ClientAdded(Client: TControl; const ARect: TRect); virtual;
    function CanResize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure AlignControls(AControl: TControl; var Rect: TRect); override;
    procedure Resize; override;
    property EnableSysButton: boolean read fEnableSysButton write SetEnableSysButton;
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    procedure DestroyWindowHandle; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CloseQuery: Boolean; override;
    procedure Paint; override;
    //C EnableClose ,    
    property EnableClose: boolean read fEnableClose write SetEnableClose;
    //     IsEnabledEx
    property UpdateInterval:integer read fUpdateInterval write SetUpdateInterval;
    property SysButtonPushed: boolean read fSysButtonPushed write SetSysButtonPushed;
  end;

  //       
  TDragDockObjectCep = class (TDragDockObjectEx)
  private
  protected
    procedure AdjustDockRect(ARect: TRect); override;
    procedure DrawDragDockImage; override;
    procedure EraseDragDockImage; override;
  public
    destructor Destroy; override;
  end;


//    '|'   
procedure SeparateCaption(var Caption, Hint:string);
//    
function CalcDockedWidthInternal(Orientation: TBarOrientation; Bar: TCustomActionDockBar; IsWidth: boolean = true): integer;

var Ctl3dFloatForms: boolean;
    MoveToCursor: boolean;

implementation
...
