unit ControlBarCep;
(*
 * Module:         
 * Version:    2.5 (23.11.2008)
 * Author:      
 * Comments:         .
 *                    
 *             email: roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   Cep Po 2007  2008 .
 *
 * Version:    2.5 (23.11.2008)
 * Realized:      Delphi 2009.
 *
 * Version:    1.0.0.0 (05.12.2007)
 *)
interface
{$I Directives.Inc}
uses Windows, Messages, RTLConsts, Types, Classes, SysUtils, Controls, Math, ActnMan,
  Graphics, GraphUtil, ExtCtrls, Themes, Forms,
  AlignBandsUtl, CepStyleUtl, ActnCtrls, InternalTimer, BitOp;

const
  CrHandMoved = 204;
  CrHandMoveable = 200;
  CrHand = 245;
  DropDownSize = 9;
  UM_CHANGED = WM_USER + 113;
  UM_EXECUTEDEX = WM_USER + 114;

type
  TMoveState = (msNone, msMove, msSize);
  TControlBarCep = class;
  TSysButtonClass = class of TSpeedButtonCepSpecial;
  TBandCepStyleClass = class of TBandCepStyle;

  //TBandCepStyle      
  //.  TControlBarCepStyle     
  //.      Bands: TBandsCepStyle.
  //     TBandCepStyle   
  TBandCepStyle = class(TBandItem)
  private
    fButtonCollection: TOwnedCollection;
    fDropDownEnabled: boolean;
    fDropDownPushed: boolean;
    fDestroying: boolean;
    fHint: string;
    function GetControlBarCepStyle: TControlBarCep;
    function GetButtonCollection: TOwnedCollection;
    function GetEnabled: boolean;
    procedure SetEnabled(const Value: boolean);
    function GetButtonCount: integer;
    function GetButtons(Index: integer): TSpeedButtonCepSpecial;
    function GetDropDownVisible: boolean;
    procedure SetDropDownVisible(const Value: boolean);
    procedure SetDropDownEnabled(const Value: boolean);
    procedure SetDropDownPushed(const Value: boolean);
    function GetDropDownChevron: boolean;
    procedure SetDropDownChevron(const Value: boolean);
    procedure onDropDownClick(Sender: TObject);
    property Parent: TControlBarCep read GetControlBarCepStyle;
    //    
    property ButtonCollection: TOwnedCollection read GetButtonCollection;
  protected
    // PaintToCanvas      
    procedure PaintToCanvas(Canvas: TCanvas;
      const OffsetX: integer = 0;
      const OffsetY: integer = 0); virtual;
    //     
    //   
    function GetBandButtonClass(Kind: TSpecialKind): TSysButtonClass; virtual;
    procedure UpdateSysArea;
    procedure ExecuteEx;
  public
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    function ButtonByKind(Kind: TSpecialKind): TSpeedButtonCepSpecial;
    property Enabled: boolean read GetEnabled write SetEnabled;
    property ButtonCount: integer read GetButtonCount;
    property Buttons[Index: integer]: TSpeedButtonCepSpecial read GetButtons;

    property Hint: string read fHint write fHint;
    property DropDownVisible: boolean read GetDropDownVisible write SetDropDownVisible;
    property DropDownEnabled: boolean read fDropDownEnabled write SetDropDownEnabled;
    property DropDownPushed: boolean read fDropDownPushed write SetDropDownPushed;
    property DropDownChevron: boolean read GetDropDownChevron write SetDropDownChevron;
  end;

  //   
  TBandsCepStyle = class(TBandItems)
  private
    function GetControlBarCepStyle: TControlBarCep;
    function GetItem(Index: Integer): TBandCepStyle;
  protected
  public
    procedure DoAligned; override;
    property Parent: TControlBarCep read GetControlBarCepStyle;
    property Items[Index: Integer]: TBandCepStyle read GetItem; default;
  end;

//      .
  TControlBarCep = class(TWinControl, IDrawBackground)
  private
    fBands: TBandsCepStyle;
    FCornerEdge: TCornerEdge;
    FGradientStartColor: TColor;
    FGradientDirection: TGradientDirection;
    FGradientEndColor: TColor;
    FDrawingStyle: TBandDrawingStyle;
    fFixed: boolean;
    FOnBandPaint: TBandPaintEvent;
    fAutoHeight, fAutoWidth: integer;
    fAligned: boolean;
    fMoveState: TMoveState;
    fPushIndex: integer;
    fPushPoint: TPoint;
    fInternalTimer: TInternalTimer;
    fSizeTick: DWORD;
    fTimer: THandle;
    fUpdateInterval: integer;
    fControlsLoaded: boolean;
    fRowSize: integer;
    fOldIsVert: Boolean;

    fDockedSysButtonPushed: boolean;
    fDockedControl: TControl;
    fDockedPoint: TSmallPoint;
    fDockedRect: TRect;
    FOnBeginBandMove: TBeginBandMoveEvent;

    function GetBands: TBandsCepStyle;
    procedure SetCornerEdge(const Value: TCornerEdge);
    procedure SetDrawingStyle(const Value: TBandDrawingStyle);
    procedure SetGradientDirection(const Value: TGradientDirection);
    procedure SetGradientEndColor(const Value: TColor);
    procedure SetGradientStartColor(const Value: TColor);
    procedure RepaintAllocated;
    procedure SetFixed(const Value: boolean);
    procedure UpdateCursor(HT: Integer);
    procedure CMControlChange(var Message: TCMControlChange); message CM_ControlChange;
    procedure CMCOLORCHANGED(var Message: TMessage); message CM_COLORCHANGED;
    procedure WMERASEBKGND(var Message: TWMERASEBKGND); message WM_ERASEBKGND;
    procedure SetPushIndex(const Value: integer);
    procedure KillTimer;
    procedure SetTimer;
    procedure SetUpdateInterval(const Value: integer);
    procedure WMTIMER(var Message: TWMTIMER); message WM_TIMER;
    procedure UMCHANGED(var Message: TMessage); message UM_CHANGED;
    procedure UMEXECUTEDEX(var Message: TMessage); message UM_EXECUTEDEX;
    procedure SetControlsLoaded(const Value: boolean);
    procedure AddControl(Control: TControl; R: TRect);
    function GetRowSize: integer;
    procedure SetRowSize(const Value: integer);
    procedure BandsChanged;
    procedure UpdateWH(Control: TControl; var W, H: Integer);
    procedure AllignButtonCollection;
  protected
    procedure AdjustSize; override;
    procedure AlignControls(AControl: TControl; var ARect: TRect); override;
    function CanAutoSize(var NewWidth, NewHeight: Integer): Boolean; override;
    procedure Resize; override;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWindowHandle(const Params: TCreateParams); override;
    procedure DestroyWindowHandle; override;
    procedure SetParent(AParent: TWinControl); override;

    procedure DoBandPaint(Control: TControl; Canvas: TCanvas; var ARect: TRect;
      var Options: TBandPaintOptions); virtual;
    procedure PaintWindow(DC: HDC); override;
    function GetBandClass: TBandCepStyleClass; virtual;
    function DrawBackgroundControl(Control: TControl; Canvas: TCanvas; ARect: TRect): boolean;
    procedure ColorsInfo(var ADrawingStyle: TBandDrawingStyle;
      var AGradientDirection: TGradientDirection;
      var AGradientStartColor: TColor;
      var AGradientEndColor: TColor;
      var AColor: TColor);
    function InsetsControl(const Control: TControl; var Insets: TRect): boolean;

    function HitTest(const X, Y: integer; var BandIndex: integer): Longint; dynamic;
    procedure UpdateBandsProperties; dynamic;
    procedure BeginMove(Control: TControl; X, Y: integer; ARect: TRect);
    procedure MouseMove(Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X: Integer; Y: Integer); override;
    procedure DblClick; override;

    procedure DockOver(Source: TDragDockObject; X, Y: Integer; State: TDragState;
      var Accept: Boolean); override;
    //  ,      
    property PushIndex: integer read fPushIndex write SetPushIndex;
    property ControlsLoaded: boolean read fControlsLoaded write SetControlsLoaded;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;

    function DoBeginBandMove(Control: TControl): Boolean; dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    //    
    function BandByControl(const Control: TControl): TBandCepStyle;
    // 
    property Bands: TBandsCepStyle read GetBands;
    property UpdateInterval: integer read fUpdateInterval write SetUpdateInterval;


  published
    //   ,   
    property CornerEdge: TCornerEdge read FCornerEdge
      write SetCornerEdge default ceMedium;
    property DrawingStyle: TBandDrawingStyle read FDrawingStyle
      write SetDrawingStyle default dsGradient;
    property GradientDirection: TGradientDirection read FGradientDirection
      write SetGradientDirection default gdVertical;
    property GradientStartColor: TColor read FGradientStartColor
      write SetGradientStartColor default clDefault;
    property GradientEndColor: TColor read FGradientEndColor
      write SetGradientEndColor default clDefault;
    property RowSize: integer read GetRowSize write SetRowSize default 32;
    property Fixed: boolean read fFixed write SetFixed default false;
    property Autosize default true;
    property ParentColor default true;
    property Align default alTop;

    property OnBandPaint: TBandPaintEvent read FOnBandPaint write FOnBandPaint;
    property OnBeginBandMove: TBeginBandMoveEvent read FOnBeginBandMove write FOnBeginBandMove;

    property Anchors;
    property BevelEdges;
    property BevelInner;
    property BevelOuter;
    property BevelKind;
//    property BevelWidth;
//    property BorderWidth;
    property Color nodefault;
    property Constraints;
    property Ctl3d;
    property DockSite;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property ParentBackground default True;
    property ParentCtl3d default true;
    property ParentFont;
    property ParentShowHint;

//    property Picture;
    property PopupMenu;
//    property RowSnap;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnAlignInsertBefore;
    property OnAlignPosition;
//    property OnBandDrag;
//    property OnBandInfo;
//    property OnBandMove;
//    property OnBeginBandMove;
//    property OnEndBandMove;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
//    property OnPaint;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;

  end;

procedure Register;

implementation
...
