unit ImageListCep;
//      
//   TImageListCep
// y     .
//       
//  roschinspb@mail.ru
//http://www.delphikingdom.com/asp/users.asp?ID=1271
//http://www.roschinspb.boom.ru
interface

uses
  windows, SysUtils, Classes, ImgList, Controls, Forms, Graphics,
  {$IFDEF VER130}Commctrl, Consts, {$ELSE}GraphUtil, {$ENDIF}GraphUtilEx,
  Math, InternalTimer;

const StandartResourceName = 'STANDARTBTN';

resourcestring
  StrNoFile = '   "%s"';

type
  TImageListCep = class;

  //       
  TResourceName = class(TCollectionItem)
  private
    fName: string;
    fWidth: Byte;
    fHeight: Byte;
    fGliphCount: Word;
    fTransparentColor: TColor;
    fAutoSize: boolean;
    fFileName: string;
    fhInstance: THandle;
    fFileNameDOM: boolean;
    procedure SetHeight(const Value: Byte);
    procedure SetName(const Value: string);
    procedure SetWidth(const Value: Byte);
    procedure SetGliphCount(const Value: Word);
    procedure SetTransparentColor(const Value: TColor);
    procedure SetAutoSize(const Value: boolean);
    procedure SetFileName(const Value: string);
    procedure FreeHinstance(RaisedError: Boolean);
    function UpdatehInstance(RaisedError: Boolean): boolean;
    procedure SetFileNameODM(const Value: boolean);
  protected
    function GetDisplayName: string; override;
    procedure SetDisplayName(const Value: string); override;
  public
    procedure Assign(Source: TPersistent); override;
    procedure LoadFromStream(S: TStream);
    procedure SaveToStream(S: TStream);
    //   (. AutoSize)
    function GetResourceName: string;
    //    (. GetResourceName, FileName, FileNameDOM)
    function LoadFromResourceName(var Bmp: TBitmap; RaisedError: boolean = false): boolean;
    //     
    procedure EnumResources(List: TStringList);
  published
    constructor Create(Collection: TCollection); override;
    destructor Destroy; override;
    property Name: string read fName write SetName; // 
    property Width: Byte read fWidth write SetWidth default 24; //  ( )
    property Height: Byte read fHeight write SetHeight default 24; // 
    // AutoSize=true,   GetResourceName
    //   NAME_ss (ss - )    
    //     Width  Height
    property AutoSize: boolean read fAutoSize write SetAutoSize default true;
    //   
    property GliphCount: Word read fGliphCount write SetGliphCount default 8;
    //,     
    property TransparentColor: TColor read fTransparentColor
      write SetTransparentColor default clFuchsia;
    //     .
    // '',   
    property FileName: string read fFileName write SetFileName;
    // FileNameDOM=true,  FileName    DesignTime,
    //     . . FileName .
    property FileNameDOM: boolean read fFileNameDOM write SetFileNameODM default true;
  end;

  // 
  TResourceNames = class(TOwnedCollection)
  private
    function GetItem(Index: Integer): TResourceName;
    procedure SetItem(Index: Integer; const Value: TResourceName);
    function GetImageList: TImageListCep;
  protected
    procedure Update(Item: TCollectionItem); override; //   
  public
    procedure Assign(Source: TPersistent); override;
    procedure BeginUpdate; override;
    procedure EndUpdate; override;
    function AddDefault: TResourceName; //    StandartBtn
    property Items[Index: Integer]: TResourceName read GetItem write SetItem;
    function FindItemByName(Name: string): integer; //    c  &
  published
    property ImageListCep: TImageListCep read GetImageList;
  end;

  // TDragImageList   
  TCustomImg = class(TDragImageList)
  private
    fSourceBitmap: TBitmap;
    fDestBitmap: TBitmap;
    fTMPBitmap: TBitmap;
    fCountUpdating: integer;
    fTimer: TInternalTimer;
    function GetTimer: TInternalTimer;
  protected
    procedure DoChanged(Sender: TObject); virtual;
    procedure Change; override;
  public
    procedure LoadFromStream(S: TStream);
    procedure SaveToStream(S: TStream);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    //    (ARect).  Index=Count, 
    //  .    .
    procedure InsertBitmap(Index: integer; Bitmap: TBitmap; ARect: TRect); overload;
    procedure InsertBitmap(Index: integer; Bitmap: TBitmap); overload;
    //  . Bitmap  
    //  
    function InsertBitmaps(Index: integer; Bitmap: TBitmap;
      Width, Height: integer; Count: integer = 0): Word;
    procedure BeginUpdate;
    procedure EndUpdate;
    property CountUpdating: integer read fCountUpdating;
    property Timer: TInternalTimer read GetTimer;
  published
    property BlendColor;
    property BkColor;
    property Height;
    property Masked;
    property Width;
  end;

  //    
  TImageListCep = class(TCustomImg)
  private
    fInChange: boolean;
    fCustomImg: TCustomImg;
    fResourceNames: TResourceNames;
    fDirName: string;
    procedure SetResourceNames(const Value: TResourceNames);
    procedure ReaderProc(Reader: TReader);
    procedure WriterProc(Writer: TWriter);
    {$IFDEF VER130}
    procedure ReadLeft(Reader: TReader);
    procedure ReadTop(Reader: TReader);
    procedure WriteLeft(Writer: TWriter);
    procedure WriteTop(Writer: TWriter);
    procedure ReadCustomImgWidth(Reader: TReader);
    procedure WriteCustomImgWidth(Writer: TWriter);
    procedure ReadCustomImgHeight(Reader: TReader);
    procedure WriteCustomImgHeight(Writer: TWriter);
    procedure ReadCustomImgBitmap(Stream: TStream);
    procedure WriteCustomImgBitmap(Stream: TStream);
    {$ENDIF}
  protected
    procedure DefineProperties(Filer: TFiler); override;
    {$IFDEF VER130}
    procedure ReadData(Stream: TStream);
    procedure WriteData(Stream: TStream);
    {$ELSE}
    procedure ReadData(Stream: TStream); override;
    procedure WriteData(Stream: TStream); override;
    {$ENDIF}
    procedure DoChanged(Sender: TObject); override;
    procedure Loaded; override;
  public
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    //   ,  
    //    ResourceNames  CustomImg
    function UpdateImages(Need: boolean = false): boolean; dynamic;
    constructor Create(AOwner: TComponent); override;
    // ,       
    property DirName: string read fDirName write fDirName;
  published
    //       
    property ResourceNames: TResourceNames read fResourceNames write SetResourceNames;
    //  ,   
    property CustomImg: TCustomImg read fCustomImg;
    property onChange;
  end;

var DesignTime: boolean;

function ResourceNameToSize(Name: string; var Size: integer): string;
procedure Register;

implementation
...
