unit NavigatorCep;
(*
 * Module:           TNavigatorCep
 * Version:    2.5 (02.12.2008)
 * Author:      
 * Comments:         .
 *                    
 *              : roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *             http://www.roschinspb.narod.ru
 *
 * Copyright:   2008 .
 *
 * Version:    2.5 (02.12.2008)
 * Realized:    SmallImages,     SmallIcons.
 *                 ,   "" (Cancel)   
 *                    (Revert).
 *)
interface
uses
  SysUtils, Classes, Windows, Controls, ToolWin, ActnMan, Messages, Graphics, GraphUtil,
  ActnList, DBActns, DB, DBClient, ExtCtrls, ActnCtrls, Forms,
  ActnMenus, XPActnCtrls, CepStyleActnCtrls, BitOp, InternalTimer, ImgList,
  ImageListCep, CepStyleUtl;

resourcestring
  CapFirst = '|   ';
  CapPrior = '|   ';
  CapState = '%0:s  %1:s| %0:s  %1:s';
  CapNext = '|   ';
  CapLast = '|   ';
  CapInsert = '|  ';
  CapDelete = '| ';
  CapEdit = '|  ';
  CapPost = '|  ';
  CapCancel = '|  ';
  CapRefresh = '|   ';
  CapApply = '|   ';
  CapRevert = '|  ';
  CapUndo = '|    ';

  CapClose = ' ';
  CapEmpty = ' ';

type
  // 
  TDBCepButton = (dcbFirst, dcbPrior, dcbState, dcbNext, dcbLast,
    dcbInsert, dcbDelete, dcbEdit, dcbPost,
    dcbCancel, dcbRefresh, dcbApply,
    dcbRevert, dcbUndo);
  // 
  TDBCepButtons = set of TDBCepButton;
  //,        
  TDBCepEvent = procedure(Sender: TObject; Action: TAction; DataSet: TDataSet; Button: TDBCepButton; var Allowed: boolean) of object;

const
  //  
  Caps: array[TDBCepButton] of string =
  (CapFirst, CapPrior, CapState, CapNext, CapLast,
    CapInsert, CapDelete, CapEdit, CapPost,
    CapCancel, CapRefresh, CapApply,
    CapRevert, CapUndo);
  //   TNavigatorCep,    
  UMRecreate = WM_USER + 139;

  DefaulButtons = [dcbFirst, dcbPrior, dcbState, dcbNext, dcbLast,
    dcbInsert, dcbDelete, dcbEdit, dcbPost,
    dcbCancel, dcbRefresh, dcbApply];

  DefaultVisibleButtons = [dcbFirst, dcbPrior, dcbState, dcbNext, dcbLast];
type
  //     .
  //    ,      
  TDataSetActionCep = class(TDataSetAction)
  private
    fDBCepButton: TDBCepButton;
    fDataSet: TDataSet;
  public
    procedure ExecuteTarget(Target: TObject); override;
    procedure UpdateTarget(Target: TObject); override;
  protected
    procedure DoCallAction(ATarget: TObject; ABeforeAction: boolean);
  public
    property DataSource;
    property DataSet: TDataSet read fDataSet;
    property DBCepButton: TDBCepButton read fDBCepButton;
  end;
  //       
  //       - ,
  //   .
  // Enabled = true,    
  // Checked = true,    
  TDataSetStateAction = class(TDataSetActionCep)
  private
    fInternalTimer: TInternalTimer;
    fRecordCount: integer;
    fRecNo: integer;
    function GetInternalTimer: TInternalTimer;
    procedure DoTimer(Sender: TObject);
  protected
    procedure Change; override;
  public
    procedure UpdateTarget(Target: TObject); override;
    destructor Destroy; override;
  end;
  //   
  TCepNavButton = class(TCepStyleButton)
  private
    fInterval: integer;
    fInternalTimer: TInternalTimer;
    fAutoClick: boolean;
   // fRecurs: boolean;
  protected
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure DoTimer(Sender: TObject); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    //   ,    
    //   
    property AutoClick: boolean read fAutoClick write fAutoClick;
    function DesignWndProc(var Message: TMessage): Boolean; override;
  end;
  //    .
  TCepStyleButtonState = class(TCepStyleButton)
  private
  protected
    procedure DrawGlyph(const Location: TPoint); override;
    procedure DrawLargeGlyph(Location: TPoint); override;
    procedure DrawBackground(var PaintRect: TRect); override;
    procedure DrawFrame(ARect: TRect; Down: Boolean); override;
    procedure CalcLayout; override;
    procedure DrawText(var ARect: TRect; var Flags: Cardinal; Text: string); override;
  public
    function DesignWndProc(var Message: TMessage): Boolean; override;
  end;
  //     ,   
  TCepNavAddRemoveItem = class(TCepStyleAddRemoveItem)
  protected
    procedure DrawGlyph(const Location: TPoint); override;
  end;
  //   ,       
  TCepNavCustomizePopup = class(TXPStyleCustomizePopup)
  private
    FARItem: TActionClientItem;
  protected
    procedure SetActionClient(const Value: TActionClient); override;
    function GetAddRemoveItemClass: TCustomAddRemoveItemClass; override;
    procedure GetSubMenuControlClass(Sender: TCustomActionBar; AnItem: TActionClient;
      var ControlClass: TCustomActionControlClass); override;
    function DoItemClicked(AnItem: TCustomActionControl): TActionClientItem; override;
  public
    procedure CloseMenu; override;
  end;
  // 
  TNavigatorCep = class(TCustomGradientActionToolBar)
  private
    fIntActionManager: TActionManager;
    fButtons: TDBCepButtons;
    fVisibleButtons: TDBCepButtons;
    fItemsCreated: boolean;
    fActions: array[TDBCepButton] of TAction;
    fARAction: TAction;
    fBeforeAction: TDBCepEvent;
    fUpdateAction: TDBCepEvent;
    fLastRefresh: DWORD;
    fWait: boolean;
    fNeedExecute: boolean;
    fAfterAction: TDBCepEvent;
    fNoPaint: DWORD;
    fItemsChanged: boolean;
    fMaxWidthState: integer;
    fTmpTimer: TInternalTimer;
    fSmallImages: boolean;
    procedure WMPAINT(var Message: TWMPAINT); message WM_PAINT;
    procedure RecreateActionManager;
    procedure RecreateItems;
    procedure SetButtons(const Value: TDBCepButtons);
    procedure SetVisibleButtons(const Value: TDBCepButtons);
    procedure ExecuteARItem(Sender: TObject);
    procedure UpdateARItem(Sender: TObject);
    function CreateButton(B: TDBCepButton): TActionClientItem;
    procedure UMRecreateItems(var Message: TMessage); message UMRecreate;
    function ActionClass(B: TDBCepButton): TContainedActionClass;
    procedure SetWait(const Value: boolean);
    procedure DoRecreateItems(Sender: TObject);
    procedure RecreateItemsDelay(Time: integer);
    function GetDataSource: TDataSource;
    procedure SetDataSource(const Value: TDataSource);
    procedure SetSmallImages(const Value: boolean);
  protected
    { Protected declarations }
    procedure SetParent(AParent: TWinControl); override;
    function GetPopupClass: TCustomActionBarClass; override;
    function GetControlClass(AnItem: TActionClientItem): TCustomActionControlClass; override;
    procedure DragOver(Source: TObject; X: Integer; Y: Integer; State: TDragState; var Accept: Boolean); override;
    function DoBeforeAction(Action: TAction; DataSet: TDataSet; Button: TDBCepButton): boolean; virtual;
    function DoUpdateAction(Action: TAction; DataSet: TDataSet; Button: TDBCepButton): boolean; virtual;
    procedure DoDropItem(Source: TActionItemDragObject; const X, Y: Integer); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
  public
    { Public declarations }
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
    procedure AfterConstruction; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property SmallIcons: boolean read fSmallImages write SetSmallImages;
    property Canvas;
  published
    { Published declarations }
    property VisibleButtons: TDBCepButtons read fVisibleButtons write SetVisibleButtons default DefaultVisibleButtons;
    property Buttons: TDBCepButtons read fButtons write SetButtons default DefaulButtons;
    property Wait: boolean read fWait write SetWait default false;
    property BeforeAction: TDBCepEvent read fBeforeAction write fBeforeAction;
    property AfterAction: TDBCepEvent read fAfterAction write fAfterAction;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property SmallImages: boolean read fSmallImages write SetSmallImages default false;
    property onUpdateAction: TDBCepEvent read fUpdateAction write fUpdateAction;

    property Align default alTop;
    property AllowHiding default True;
    property Anchors;
    property AutoSize;
    property BiDiMode;
    property Caption;
    property Color default clBtnFace;
    property ColorMap;
    property Constraints;
    property Cursor;
    property DragCursor;
    property DragKind default dkDock;
    property DragMode;
    property EdgeBorders default [];
    property EdgeInner;
    property EdgeOuter default esNone;
    property Enabled;
    property Font;
    property HorzMargin;
    property HorzSeparator default True;
    property Orientation default boLeftToRight;
    property ParentBiDiMode;
    property ParentBackground default False;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property PersistentHotKeys default False;
    property PopupMenu;
    property ShowHint;
    property Spacing;
    property VertMargin;
    property Visible;
    property OnAlignInsertBefore;
    property OnAlignPosition;
    property OnControlCreated;
    property OnCanResize;
    property OnClick;
    property OnConstrainedResize;
    property OnContextPopup;
    property OnDockDrop;
    property OnDockOver;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnGetControlClass;
    property OnGetSiteInfo;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint;
    property OnResize;
    property OnStartDock;
    property OnStartDrag;
    property OnUnDock;
  end;

procedure Register;

implementation
...
