unit FormImageListCep;
(*
 * Module:            TImageListCep
 * Version:    1.6 (27.11.2007)
 * Author:      
 * Comments:    y     .
 *                    
 *               roschinspb@mail.ru
 *             http://www.delphikingdom.com/asp/users.asp?ID=1271
 *
 * Copyright:   2007 .
 *)
interface
{$I ..\Directives.inc}
uses
  Windows, Messages, SysUtils,
  Classes, Graphics, Controls,
  Forms, Dialogs, ImgList, ImageListCep,
  ActnList, Grids, SysConst,
  ExtDlgs, StdCtrls, ExtCtrls, Mask
  , jpeg{, PNGIMAGE};

resourcestring
  StrSDxdd = '%s (%dx%d) [%d]';
  StrAOwnerError = 'AOwner   TFormDlgSIL';
  ResLoadError = ' %d    "%s"'+#13#10+'%s';
  ErrorFormat = ' "%s"  ';

type
  TTypeAdd = (taScale, taCenter, taDiv);

  TFormOpenResource = class (TCustomForm)
  private
    fHotIndex:integer;
    fSelIndexes:array of integer;
    fPaintBox: TControl;
    fFileName: String;
    fResourceName: string;
    fhInstance: Integer;
    fIcons: TStringList;
    fImageWidth: integer;
    fImageHeight: integer;
    procedure SetFileName(const Value: string);
    procedure FreeHinstance;
    procedure UpdateHinstance;
    function NameByIndex(Index: integer): string;
    function IsSelectedIndex(Index: integer): boolean;
    procedure SelectIndex(Index: integer);
    procedure UnSelectIndex(Index: integer);
    procedure ClickOk(Sender:TObject);
    procedure ClickCancel(Sender:TObject);
  protected
  published
    constructor Create(AOwner:TComponent; AImageWidth:integer=32; AImageHeight:integer=32); reintroduce;
    property FileName:string read fFileName write SetFileName;
    property ResourceName:string read fResourceName;
    property ImageWidth: integer read fImageWidth;
    property ImageHeight: integer read fImageHeight;
    destructor Destroy; override;
  end;

  TFormProp = class (TCustomForm)
  private
   fChild: TPersistent;
   feWidth: TMaskEdit;
   feHeight: TMaskEdit;
   feCount: TMaskEdit;
   {$IFDEF VER130} {$ELSE}
   fColorBox: TColorBox;
   {$ENDIF}
   fResourceBox: TComboBox;
   fEditFileName: TMaskEdit;
   fButtonBrowse:TButton;
   fDLGopen:TOpenDialog;
   fCheckAuto:TCheckBox;
   fCheckDOM:TCheckBox;
   procedure ClickOk(Sender:TObject);
   procedure ClickBrowse(Sender:TObject);
    procedure UpdateResourceNames;
    procedure ClickAuto(Sender: TObject);
    procedure UpdateEnableSize;
    procedure ClickDom(Sender: TObject);
  public
   constructor Create(AOwner:TComponent; AChild:TPersistent); reintroduce;
   procedure DoShow; override;
   property Child: TPersistent read fChild;
  end;

  TOpenPictureDialogCep = class (TOpenPictureDialog)
  private
    {$IFDEF VER130}
    {$ELSE}
    FSavedFilename: string;
    {$ENDIF}
  protected
    procedure DoSelectionChange; override;
  private

  end;

  TFormDlgSIL = class(TForm)
    ButtonAdd: TButton;
    ActionList1: TActionList;
    ActionAdd: TAction;
    ActionInsert: TAction;
    ButtonInsert: TButton;
    ActionDel: TAction;
    ButtonDelete: TButton;
    GroupTypeAdd: TRadioGroup;
    GroupSize: TGroupBox;
    Label1: TLabel;
    EHeight: TMaskEdit;
    eWidth: TMaskEdit;
    CDefaultSize: TCheckBox;
    ActionApply: TAction;
    ButtonApply: TButton;
    ButtonCancel: TButton;
    ActionClose: TAction;
    ActionOk: TAction;
    ButtonOk: TButton;
    ActionMoveNext: TAction;
    ActionMovePrior: TAction;
    ButtonProps: TButton;
    ActionAddStandart: TAction;
    ActionDelResource: TAction;
    ActionPropResource: TAction;
    ActionProps: TAction;
    ActionExport: TAction;
    ButtonExport: TButton;
    SaveDialog1: TSaveDialog;
    ActionExportAll: TAction;
    ActionAddResource: TAction;
    procedure InternalImageListChange(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ActionAddExecute(Sender: TObject);
    procedure ActionInsertExecute(Sender: TObject);
    procedure ActionDelUpdate(Sender: TObject);
    procedure ActionDelExecute(Sender: TObject);
    procedure MEKeyPress(Sender: TObject; var Key: Char);
    procedure EChange(Sender: TObject);
    procedure CDefaultSizeClick(Sender: TObject);
    procedure GroupTypeAddClick(Sender: TObject);
    procedure ActionPriorExecute(Sender: TObject);
    procedure ActionNextExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ActionApplyExecute(Sender: TObject);
    procedure ActionCloseExecute(Sender: TObject);
    procedure ActionOkExecute(Sender: TObject);
    procedure ActionMoveNextExecute(Sender: TObject);
    procedure ActionMovePriorExecute(Sender: TObject);
    procedure ActionAddStandartExecute(Sender: TObject);
    procedure ActionAddBBResourceExecute(Sender: TObject);
    procedure ActionAddStandartUpdate(Sender: TObject);
    procedure ActionDelResourceExecute(Sender: TObject);
    procedure ActionPropResourceExecute(Sender: TObject);
    procedure ActionPropsExecute(Sender: TObject);
    procedure ActionExportExecute(Sender: TObject);
    procedure ActionExportUpdate(Sender: TObject);
    procedure ActionExportAllExecute(Sender: TObject);
    procedure ActionAddResourceExecute(Sender: TObject);
  private
    { Private declarations }
    fItemIndex: integer;
    fAddedWidth:integer;
    fAddedHeight:integer;
    fAddedDefaultSize: boolean;
    fTypeAdd: TTypeAdd;
    fInternalImageList: TImageListCep;
    fImageListCep: TImageListCep;
    fGrid:TCustomGrid;
    fItemDel: TObject;
    fItemProp: TObject;
    fOpenPictureDialogCep: TOpenPictureDialogCep;
    fModified: boolean;
    procedure OpenFile(FileName:string; Index:integer; Image: TImage=nil);
    procedure SetItemIndex(const Value: integer);
    procedure SetAddedHeight(const Value: integer);
    procedure SetAddedWidth(const Value: integer);
    procedure SetAddedDefaultSize(const Value: boolean);
    procedure SetTypeAdd(const Value: TTypeAdd);
    procedure UpdateESize;
    procedure SetInternalImageList(const Value: TImageListCep);
    procedure SetImageListCep(const Value: TImageListCep);
    procedure CreatePopupMenuGrid(const SelResource: Integer);
    procedure PopupUpdate(Sender: TObject);
    function CreateMenuItem(Action: TAction):TObject;
    procedure UpdateGrid;
    procedure UpdateCaption;
    procedure SaveToRes(B: TBitmap);
    procedure DoExport(All: Boolean);
    procedure DrawPreview(IMGList: TImageListCep; Image: TImage);
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    //        
    //         False
    function LoadFiles(Ext: String;      //  
                       Instance: hinst;  //   
                       FileNames: string;//  ,   ( Instance<>0)
                       Width, Height: integer; //   
                   var Bitmap: TBitmap):boolean; virtual;
    procedure DoShow; override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    destructor Destroy; override;
    property Modified: boolean read fModified;
    property ItemIndex:integer read fItemIndex write SetItemIndex;
    property AddedWidth:integer read fAddedWidth write SetAddedWidth;
    property AddedHeight:integer read fAddedHeight write SetAddedHeight;
    property AddedDefaultSize:boolean read fAddedDefaultSize write SetAddedDefaultSize;
    property TypeAdd:TTypeAdd read fTypeAdd write SetTypeAdd;
    property InternalImageList:TImageListCep read fInternalImageList;
    property ImageListCep:TImageListCep read fImageListCep write SetImageListCep;
    property OpenPictureDialogCep: TOpenPictureDialogCep read fOpenPictureDialogCep;
  end;

var
  FormDlgSIL: TFormDlgSIL;

const Margin=8;

implementation
...
