unit ufSettings;
(*
 * Module:      ""    
 * Version:    1.1.0.0 (24.09.2008)
 * Author:     Cep Po
 *
 * Copyright:   2008 Cep Po
 *
 * Version:    1.1.0.0 (24.09.2008)
 * Realized:      
 *)
interface
{$I Directives.inc}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, TextUtlCep;

resourcestring
  CodePages = '1251| windows-1251| ANSI Cyrillic; Cyrillic (Windows)|' +
    '0|ANSI| All simbol no represented|' +
    '1200| Unicode| All simbol represented|' +
    '1250| windows-1250| ANSI Central European; Central European (Windows)|' +
    '1252| windows-1252| ANSI Latin 1; Western European (Windows)|' +
    '1253| windows-1253| ANSI Greek; Greek (Windows)|' +
    '1254| windows-1254| ANSI Turkish; Turkish (Windows)|' +
    '1255| windows-1255| ANSI Hebrew; Hebrew (Windows)|' +
    '1256| windows-1256| ANSI Arabic; Arabic (Windows)|' +
    '1257| windows-1257| ANSI Baltic; Baltic (Windows)|' +
    '1258| windows-1258| ANSI/OEM Vietnamese; Vietnamese (Windows)';
type
  TFormSettings = class(TForm)
    cbCodePage: TComboBox;
    Label1: TLabel;
    cbHex: TCheckBox;
    eFirstLeft: TMaskEdit;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    eLeft: TMaskEdit;
    eRight: TMaskEdit;
    GroupBox2: TGroupBox;
    cbWantReturns: TCheckBox;
    cbWantTabs: TCheckBox;
    cbNoComments: TCheckBox;
    procedure cbCodePageChange(Sender: TObject);
    procedure cbHexClick(Sender: TObject);
    procedure eKeyPress(Sender: TObject; var Key: Char);
    procedure eFirstLeftChange(Sender: TObject);
    procedure eLeftChange(Sender: TObject);
    procedure eRightChange(Sender: TObject);
    procedure eExit(Sender: TObject);
    procedure cbWantClick(Sender: TObject);
    procedure cbNoCommentsClick(Sender: TObject);
  private
    { Private declarations }
    fListCodePages: TStringList;
    fonChanged: TNotifyevent;
    fFirstTextLeft: integer;
    fTextLeft: integer;
    fTextRight: integer;
    function GetCodePage: Cardinal;
    procedure UpdateText;
    procedure SetFirstTextLeft(const Value: integer);
    procedure SetTextLeft(const Value: integer);
    procedure SetTextRight(const Value: integer);
    function SenderValue(Sender: TObject): integer;
    function GetWantTabs: boolean;
    procedure SetWantTabs(const Value: boolean);
    procedure SetCheckValue(ACheckBox: TCheckBox; const Value: Boolean);
    function GetWantReturns: boolean;
    procedure SetWantReturns(const Value: boolean);
    function GetNoComments: boolean;
    procedure SetNoComments(const Value: boolean);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure DoChanged;
    property CodePage: Cardinal read GetCodePage;
    property onChanged: TNotifyevent read fonChanged write fonChanged;
    property FirstTextLeft: integer read fFirstTextLeft write SetFirstTextLeft;
    property TextLeft: integer read fTextLeft write SetTextLeft;
    property TextRight: integer read fTextRight write SetTextRight;
    property WantTabs: boolean read GetWantTabs write SetWantTabs;
    property WantReturns: boolean read GetWantReturns write SetWantReturns;
    property NoComments: boolean read GetNoComments write SetNoComments;
  end;

implementation
...
