unit ufSpecInst;
(*
 * Module:      " "
 * Version:    1.1.0.0 (24.09.2008)
 * Author:     Cep Po
 *
 * Copyright:   2008 Cep Po
 *
 * Version:    1.1.0.0 (24.09.2008)
 * Realized:     Delphi 2009
 *                
 *)
interface
{$I Directives.inc}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, RICHEDIT, ImgList, ActnList, ExtCtrls, Buttons,
  {$IFDEF DELPHI_6_UP}{$ELSE}GraphUtilEx, {$ENDIF}
  ToolWin, Consts, ComStrs, ufSettings,
  SHFolder, IniFiles, Math, uBaseForm, ImageListCep, SpeedButtonCep,
  TextUtlCep;

resourcestring
  textAnd = '%s' + #13#10 + ' %s';
const
  FormSettingsName = 'FormSettings';

type

  TFormSpecIns = class(TBaseForm)
    Panel1: TPanel;
    Panel2: TPanel;
    RichEdit1: TRichEdit;
    Splitter1: TSplitter;
    RichEdit2: TRichEdit;
    actInsert: TAction;
    actCopyToCB: TAction;
    actPasteFromCB: TAction;
    actSettings: TAction;
    ToolBar1: TToolBar;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    procedure actCopyToCBExecute(Sender: TObject);
    procedure actPasteFromCBUpdate(Sender: TObject);
    procedure actPasteFromCBExecute(Sender: TObject);
    procedure actDefaultUpdate(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
    procedure actDefaultExecute(Sender: TObject);
    procedure actSettingsUpdate(Sender: TObject);
    procedure actSettingsExecute(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure actInsertUpdate(Sender: TObject);
    procedure actInsertExecute(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure RichEdit2Change(Sender: TObject);
    procedure RichEdit1Enter(Sender: TObject);
    procedure RichEdit2Enter(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    fCodeChadge: boolean;
    fFormSettings: TFormSettings;
    fIniFileName: string;
    fSelLength: integer;
    fSelStart: integer;
    fSelColumn: integer;
    fLiteralText: TLiteralText;
    fStripText: WideString;
    fTokenText: WideString;
    fonChangeSelection: TNotifyEvent;
    fonInsert: TNotifyEvent;
    fNeedUpdate: boolean;
    fInCode: boolean;
    fCopyAfterShow: boolean;
    fOldNoComments: boolean;
    fOldStart: integer;
    fOldEnd: integer;
    fOldOffset: integer;
    fOldStripText: WideString;
    fOldResult: boolean;
    fWait: TObject;

    function GetInCode: boolean;
    procedure SetInCode(const Value: boolean);
    procedure SettingsChange(Sender: TObject);
    procedure SetIniFileName(const Value: string);
    function GetCodeText(const TextW: WideString): WideString;
    procedure SetSelLength(const Value: integer);
    procedure SetSelStart(const Value: integer);
    procedure SetLiteralText(const Value: TLiteralText);
    function UpdateSelectedText: boolean;
    procedure ChangeSelection; virtual;
    procedure UpdateInCode;
    function GetStripText(const Offset: Integer; var StartPos,
      EndPos: Integer; var S: WideString): boolean;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure AfterConstruction; override;
    destructor Destroy; override;
    property IniFileName: string read fIniFileName write SetIniFileName;
    procedure DoShow; override;
    procedure DoInit;
    property InCode: boolean read GetInCode write SetInCode;
    property LiteralText: TLiteralText read fLiteralText write SetLiteralText;
    property SelStart: integer read fSelStart write SetSelStart;
    property SelLength: integer read fSelLength write SetSelLength;
    procedure SetSel(SelStart, SelLength: integer; Column: integer = 0) overload;
    property SelColumn: integer read fSelColumn;
    property CopyAfterShow: boolean read fCopyAfterShow write fCopyAfterShow;

    procedure BeginWait;
    procedure StopWait;

    property TokenText: WideString read fTokenText;
    property StripText: WideString read fStripText;
    property onChangeSelection: TNotifyEvent read fonChangeSelection write fonChangeSelection;
    property onInsert: TNotifyEvent read fonInsert write fonInsert;
  end;

function DefaultIniFileName(Name: string): string;

implementation
...
